package sun.awt.windows;

import sun.awt.SunToolkit;
import java.awt.event.ItemEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.Checkbox;
import java.awt.Dimension;
import java.awt.CheckboxGroup;
import java.awt.peer.CheckboxPeer;

final class WCheckboxPeer extends WComponentPeer implements CheckboxPeer
{
    @Override
    public native void setState(boolean p0);
    
    @Override
    public native void setCheckboxGroup(CheckboxGroup p0);
    
    @Override
    public native void setLabel(String p0);
    
    private static native int getCheckMarkSize();
    
    @Override
    public Dimension getMinimumSize() {
        String label = ((Checkbox)this.target).getLabel();
        int checkMarkSize = getCheckMarkSize();
        if (label == null) {
            label = "";
        }
        FontMetrics fontMetrics = this.getFontMetrics(((Checkbox)this.target).getFont());
        return new Dimension(fontMetrics.stringWidth(label) + checkMarkSize / 2 + checkMarkSize, Math.max(fontMetrics.getHeight() + 8, checkMarkSize));
    }
    
    @Override
    public boolean isFocusable() {
        return true;
    }
    
    WCheckboxPeer(Checkbox checkbox) {
        super(checkbox);
    }
    
    @Override
    native void create(WComponentPeer p0);
    
    @Override
    void initialize() {
        Checkbox checkbox = (Checkbox)this.target;
        this.setState(checkbox.getState());
        this.setCheckboxGroup(checkbox.getCheckboxGroup());
        Color background = ((Component)this.target).getBackground();
        if (background != null) {
            this.setBackground(background);
        }
        super.initialize();
    }
    
    @Override
    public boolean shouldClearRectBeforePaint() {
        return false;
    }
    
    void handleAction(final boolean b) {
        final Checkbox target = (Checkbox)this.target;
        SunToolkit.executeOnEventHandlerThread(target, new Runnable() {
            @Override
            public void run() {
                CheckboxGroup checkboxGroup = target.getCheckboxGroup();
                if (checkboxGroup != null && target == checkboxGroup.getSelectedCheckbox() && target.getState()) {
                    return;
                }
                target.setState(b);
                WCheckboxPeer.this.postEvent(new ItemEvent(target, 701, target.getLabel(), b ? 1 : 2));
                return;
            }
        });
    }
}
